#!/bin/bash

WORK_DIR=$(cd $(dirname $0);pwd)
cd $WORK_DIR

Usage="Usage : update.sh -u ExecuteUser NoraExternalConnector_vx.x.x.zip"

ExecuteUser="$SUDO_USER"

if [ ! "$USER" = "root" ]; then
    echo "Please execute sudo or root !" 1>&2
    exit 1
fi

while getopts u: OPT
do
  case $OPT in
    "u" ) ExecuteUser="$OPTARG" ;;
    * ) echo "$Usage" 1>&2
        exit 1 ;;
  esac
done

shift `expr $OPTIND - 1`

ArchiveFilePath="$1"

if [ ! -e "$ArchiveFilePath" ]; then
    echo "Could not found $ArchiveFilePath" 1>&2
    exit 1
fi


echo "NoraExternalConnector SimpleUpdater"
echo ""
echo "User:$ExecuteUser"
echo ""

echo "[1] Backup config file..."
cp ./config/NoraExternalConnector.xml ./config/NoraExternalConnector.xml.backup

echo "[2] Backup hosts file..."
cp ./config/hosts.txt ./config/hosts.txt.backup

echo "[3] Remove NoraExternalConnector application jar"
rm ./NoraExternalConnector*.jar

echo "[4] Extract $1"
unzip -o $1 -d ../ >/dev/null 2>&1

echo "[5] Change Permission"
if [ ! -e ./NoraExternalConnector.status ]; then
    touch ./NoraExternalConnector.status
fi
chown -R $ExecuteUser:$ExecuteUser ../NoraExternalConnector
chmod 755 ./log
chmod 644 ./log/*
chmod 644 ./NoraExternalConnector.status
chmod 744 ./*.sh

if [ -e ./config/NoraExternalConnector.xml ]; then
    echo "[6] Generate configuration diff to ./config/NoraExternalConnector.xml.diff"
    diff ./config/NoraExternalConnector.xml.default ./config/NoraExternalConnector.xml > ./config/NoraExternalConnector.xml.diff
fi

echo "Complete !"

exit 0
